// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "WHLLAPI3270.h"
#include "ChildView.h"
#include "WHLLAPI3270UserInput.h"

#define _countof(array) (sizeof(array)/sizeof(array[0]))

// Change the following define to a comment to do a static link with Whllapi.lib
// instead of using LoadLibrary/GetProcAddress
#define _USE_LOADLIBRARY_

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	CString str = AfxGetApp()->GetProfileString("Settings", "SessionID", "A");
	m_cSessionID = str[0];
	m_strSendCommand = AfxGetApp()->GetProfileString("Settings", "SendCommand", "<Send command>");
	m_strReceiveCommand = AfxGetApp()->GetProfileString("Settings", "ReceiveCommand", "<Receive command>");
	m_strEmulatorPath = AfxGetApp()->GetProfileString("Settings", "EmulatorPath", "<path to executable file>");
	m_strEmulatorParameters = AfxGetApp()->GetProfileString("Settings", "EmulatorParameters", "<Command line parameters>");
	m_bEAB = FALSE;

	m_nVScrollPos = m_nVPageSize = 0;
	m_cx = m_cy = 0;

	m_pfnWinHLLAPI = NULL;
	m_pfnWinHLLAPIStartup = NULL;
	m_pfnWinHLLAPICleanup = NULL;
#ifdef _USE_LOADLIBRARY_
	CString strDLLName = AfxGetApp()->GetProfileString("Settings", "DLLName", "Whllapi.dll");
	m_hLib = LoadLibrary(strDLLName);
	if (m_hLib)
	{
		m_pfnWinHLLAPI = (PFNWinHLLAPI)GetProcAddress(m_hLib, "WinHLLAPI");
		m_pfnWinHLLAPIStartup = (PFNWinHLLAPIStartup)GetProcAddress(m_hLib, "WinHLLAPIStartup");
		m_pfnWinHLLAPICleanup = (PFNWinHLLAPICleanup)GetProcAddress(m_hLib, "WinHLLAPICleanup");
	}
#else
	m_pfnWinHLLAPI = &WinHLLAPI;
	m_pfnWinHLLAPIStartup = &WinHLLAPIStartup;
	m_pfnWinHLLAPICleanup = &WinHLLAPICleanup;
#endif // _USE_LOADLIBRARY_

	if (m_pfnWinHLLAPI == NULL ||
		m_pfnWinHLLAPIStartup == NULL ||
		m_pfnWinHLLAPICleanup == NULL
#ifdef _USE_LOADLIBRARY_
		|| m_hLib == NULL
#endif // _USE_LOADLIBRARY_
		)
	{
		CString str("WinHLLAPI initialization failed!");
		AfxMessageBox(str);
		m_astrResults.Add(str);
	}

	if (m_pfnWinHLLAPIStartup)
	{
		WHLLAPIDATA Data;
		CString str;
		int nRet = m_pfnWinHLLAPIStartup(MAKEWORD(1,0), &Data);
		m_astrResults.Add("WinHLLAPIStartup()");
		str.Format("    Return code: %d (%s)", nRet, GetReturnCodeVerbose(nRet));
		m_astrResults.Add(str);
		str.Format("        Version: %d.%d", LOBYTE(Data.wVersion), HIBYTE(Data.wVersion));
		m_astrResults.Add(str);
		str.Format("    Description: %s", Data.szDescription);
		m_astrResults.Add(str);
	}
}

CChildView::~CChildView()
{
	if (m_pfnWinHLLAPI)
		CallWinHLLAPI(RESETSYSTEM);
	if (m_pfnWinHLLAPICleanup)
		m_pfnWinHLLAPICleanup();

#ifdef _USE_LOADLIBRARY_
	if (m_hLib)
		FreeLibrary(m_hLib);
#endif // _USE_LOADLIBRARY_

	CString str(m_cSessionID);
	AfxGetApp()->WriteProfileString("Settings", "SessionID", str);
	AfxGetApp()->WriteProfileString("Settings", "SendCommand", m_strSendCommand);
	AfxGetApp()->WriteProfileString("Settings", "ReceiveCommand", m_strReceiveCommand);
	AfxGetApp()->WriteProfileString("Settings", "EmulatorPath", m_strEmulatorPath);
	AfxGetApp()->WriteProfileString("Settings", "EmulatorParameters", m_strEmulatorParameters);
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_COMMAND(ID_FUNCTION_CONNECT, OnFunctionConnectPS)
	ON_COMMAND(ID_FUNCTION_DISCONNECT, OnFunctionDisconnectPS)
	ON_COMMAND(ID_FUNCTION_CONVERT, OnFunctionConvert)
	ON_COMMAND(ID_FUNCTION_SET_SESSION_PARMS, OnFunctionSetSessionParms)
	ON_COMMAND(ID_FUNCTION_SET_CURSOR, OnFunctionSetCursor)
	ON_COMMAND(ID_FUNCTION_QUERY_CURSOR, OnFunctionQueryCursor)
	ON_COMMAND(ID_FUNCTION_QUERY_SYSTEM, OnFunctionQuerySystem)
	ON_COMMAND(ID_FUNCTION_QUERY_SESSIONS, OnFunctionQuerySessions)
	ON_COMMAND(ID_FUNCTION_QUERY_SESSION_STATUS, OnFunctionQuerySessionStatus)
	ON_COMMAND(ID_FUNCTION_COPY_FIELD_TO_STRING, OnFunctionCopyFieldToString)
	ON_COMMAND(ID_FUNCTION_COPY_PS, OnFunctionCopyPs)
	ON_COMMAND(ID_FUNCTION_COPY_PS_TO_STRING, OnFunctionCopyPsToString)
	ON_COMMAND(ID_FUNCTION_QUERY_FIELD_ATTRIBUTE, OnFunctionQueryFieldAttribute)
	ON_COMMAND(ID_FUNCTION_START_HOST_NOTIFY, OnFunctionStartHostNotify)
	ON_COMMAND(ID_FUNCTION_STOP_HOST_NOTIFY, OnFunctionStopHostNotify)
	ON_COMMAND(ID_FUNCTION_PAUSE, OnFunctionPause)
	ON_COMMAND(ID_FUNCTION_QUERY_HOST_UPDATE, OnFunctionQueryHostUpdate)
	ON_COMMAND(ID_FUNCTION_FIND_FIELD_LENGTH, OnFunctionFindFieldLength)
	ON_COMMAND(ID_FUNCTION_FIND_FIELD_POSITION, OnFunctionFindFieldPosition)
	ON_COMMAND(ID_FUNCTION_SEND_KEY, OnFunctionSendKey)
	ON_COMMAND(ID_FUNCTION_RESERVE, OnFunctionReserve)
	ON_COMMAND(ID_FUNCTION_RELEASE, OnFunctionRelease)
	ON_COMMAND(ID_FUNCTION_START_KEYSTROKE_INTERCEPT, OnFunctionStartKeystrokeIntercept)
	ON_COMMAND(ID_FUNCTION_STOP_KEYSTROKE_INTERCEPT, OnFunctionStopKeystrokeIntercept)
	ON_COMMAND(ID_FUNCTION_GET_KEY, OnFunctionGetKey)
	ON_COMMAND(ID_FUNCTION_POST_INTERCEPT_STATUS, OnFunctionPostInterceptStatus)
	ON_COMMAND(ID_FUNCTION_COPY_STRING_TO_PS, OnFunctionCopyStringToPs)
	ON_COMMAND(ID_FUNCTION_COPY_STRING_TO_FIELD, OnFunctionCopyStringToField)
	ON_COMMAND(ID_FUNCTION_RESET_SYSTEM, OnFunctionResetSystem)
	ON_COMMAND(ID_FUNCTION_WAIT, OnFunctionWait)
	ON_COMMAND(ID_FUNCTION_SEARCH_FIELD, OnFunctionSearchField)
	ON_COMMAND(ID_FUNCTION_SEARCH_PS, OnFunctionSearchPs)
	ON_COMMAND(ID_FUNCTION_SEND_FILE, OnFunctionSendFile)
	ON_COMMAND(ID_FUNCTION_RECEIVE_FILE, OnFunctionReceiveFile)
	ON_COMMAND(ID_FUNCTION_COPY_OIA, OnFunctionCopyOIA)
	ON_COMMAND(ID_FUNCTION_START_CLOSE_INTERCEPT, OnFunctionStartCloseIntercept)
	ON_COMMAND(ID_FUNCTION_STOP_CLOSE_INTERCEPT, OnFunctionStopCloseIntercept)
	ON_COMMAND(ID_FUNCTION_QUERY_CLOSE_INTERCEPT, OnFunctionQueryCloseIntercept)
	ON_COMMAND(ID_FUNCTION_CONNECT_WINDOW_SERVICES, OnFunctionConnectWindowServices)
	ON_COMMAND(ID_FUNCTION_DISCONNECT_WINDOW_SERVICES, OnFunctionDisconnectWindowServices)
	ON_COMMAND(ID_FUNCTION_QUERY_WINDOW_COORDINATES, OnFunctionQueryWindowCoordinates)
	ON_COMMAND(ID_FUNCTION_WINDOW_STATUS_QUERY, OnFunctionWindowStatusQuery)
	ON_COMMAND(ID_FUNCTION_WINDOW_STATUS_SET, OnFunctionWindowStatusSet)
	ON_COMMAND(ID_FUNCTION_CHANGE_PS_WINDOW_NAME, OnFunctionChangePSWindowName)
	ON_COMMAND(ID_FUNCTION_START_EMULATOR, OnFunctionStartEmulator)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView window message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

BOOL CChildView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	BOOL bRc = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, 
							rect, pParentWnd, nID, pContext);

	CClientDC dc(this);
	dc.SelectStockObject(ANSI_FIXED_FONT);
	TEXTMETRIC tm;
	dc.GetTextMetrics(&tm);
	m_cx = (short)tm.tmAveCharWidth;
	m_cy = (short)(tm.tmHeight + tm.tmExternalLeading);

	return bRc;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	dc.SetWindowOrg(0, m_nVScrollPos * m_cy);
	dc.SelectStockObject(ANSI_FIXED_FONT);
	int nMaxLines = min(m_astrResults.GetSize(), m_nVScrollPos + m_nVPageSize + 1);
	for (int i = m_nVScrollPos; i < nMaxLines; i++)
		dc.TextOut(0, i * m_cy, m_astrResults[i], m_astrResults[i].GetLength());

	// Do not call CWnd::OnPaint() for painting messages
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
	if (m_cy > 0)
	{
		m_nVPageSize = cy / m_cy;
		UpdateScrollSizes((m_astrResults.GetSize() < m_nVPageSize) ? 0 : m_nVScrollPos);
	}
}

void CChildView::UpdateScrollSizes(int nVScrollPos)
{
	m_nVScrollPos = nVScrollPos;
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	si.nPage = m_nVPageSize;
	si.nMin  = 0;
	si.nMax = m_astrResults.GetSize() - 1;
	si.nPos = m_nVScrollPos;
	SetScrollInfo(SB_VERT, &si, TRUE);
}

void CChildView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int nDelta;
	int nMaxPos = max(m_astrResults.GetSize() - m_nVPageSize, 0);
	switch (nSBCode)
	{
	case SB_LINEUP:
		if (m_nVScrollPos <= 0)
			return;
		nDelta = -1;
		break;
	case SB_PAGEUP:
		if (m_nVScrollPos <= 0)
			return;
		nDelta = -(min(m_nVPageSize, m_nVScrollPos));
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nDelta = (int)nPos - m_nVScrollPos;
		break;
	case SB_PAGEDOWN:
		if (m_nVScrollPos >= nMaxPos)
			return;
		nDelta = min(m_nVPageSize, nMaxPos - m_nVScrollPos);;
		break;
	case SB_LINEDOWN:
		if (m_nVScrollPos >= nMaxPos)
			return;
		nDelta = 1;
		break;
	default:
		return;
	}
	m_nVScrollPos += nDelta;
	SetScrollPos(SB_VERT, m_nVScrollPos, TRUE);
	ScrollWindow(0, -(nDelta * m_cy));
}

/////////////////////////////////////////////////////////////////////////////
// CChildView menu item message handlers

void CChildView::OnFunctionConnectPS() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;
	m_cSessionID = str1.IsEmpty() ? '\0' : str1[0];

	CallWinHLLAPI(CONNECTPS, (LPBYTE)&m_cSessionID, 1);
	ShowResults((LPBYTE)&m_cSessionID, 1);
}

void CChildView::OnFunctionDisconnectPS() 
{
	CallWinHLLAPI(DISCONNECTPS);
	ShowResults();
}

void CChildView::OnFunctionConvert() 
{
	CString str1 = m_cSessionID;
	str1 += "< + P for Position | R for Row/column>";
	CString str2 = "<P=position | R=row,column>";
	if (!GetUserInput(&str1, &str2))
		return;
	while (str1.GetLength() < 2)
		str1 += ' ';

	WORD wLength = 0;
	WORD wPSPosition = 0;
	if (str1[1] == 'P')
	{
		wPSPosition = atoi(str2);
	}
	else if (str1[1] == 'R')
	{
		wLength = atoi(GetToken(str2));
		wPSPosition = atoi(str2);
	}

	CallWinHLLAPI(CONVERT, (LPBYTE)((LPCTSTR)str1), wLength, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str1), 2);
}

void CChildView::OnFunctionSetSessionParms() 
{
	CString str1 = "<Enter session parameters>";
	if (!GetUserInput(&str1))
		return;

	CString str2 = str1;
	while (!str2.IsEmpty())
	{
		CString strToken = GetToken(str2);
		if (strToken.CompareNoCase("EAB") == 0)
			m_bEAB = TRUE;
		else if (strToken.CompareNoCase("NOEAB") == 0)
			m_bEAB = FALSE;
	}
	CallWinHLLAPI(SETSESSIONPARAMETERS, (LPBYTE)((LPCTSTR)str1), str1.GetLength());
	ShowResults((LPBYTE)((LPCTSTR)str1), str1.GetLength());
}

void CChildView::OnFunctionSetCursor() 
{
	CString str1 = "<Enter cursor position>";
	if (!GetUserInput(&str1))
		return;

	WORD wPSPosition = atoi(str1);
	CallWinHLLAPI(SETCURSOR, NULL, 0, wPSPosition);
	ShowResults();
}

void CChildView::OnFunctionQueryCursor() 
{
	CallWinHLLAPI(QUERYCURSORLOC);
	ShowResults();
}

void CChildView::OnFunctionQuerySystem() 
{
	BYTE sSystemStatus[35];
	CallWinHLLAPI(QUERYSYSTEM, sSystemStatus);
	ShowResults(sSystemStatus, sizeof(sSystemStatus));
}

void CChildView::OnFunctionQuerySessions() 
{
	BYTE sSessions[26][12];
	CallWinHLLAPI(QUERYSESSIONS, (LPBYTE)&sSessions, sizeof(sSessions));
	ShowResults((LPBYTE)&sSessions, m_wLength * sizeof(sSessions[0]));
}

void CChildView::OnFunctionQuerySessionStatus() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	BYTE sSessionStatus[18];
	sSessionStatus[0] = str1.IsEmpty() ? m_cSessionID : str1[0];
	CallWinHLLAPI(QUERYSESSIONSTATUS, sSessionStatus, sizeof(sSessionStatus));
	ShowResults(sSessionStatus, sizeof(sSessionStatus));
}

void CChildView::OnFunctionCopyOIA() 
{
	BYTE sOIA[103];
	CallWinHLLAPI(COPYOIA, sOIA, sizeof(sOIA));
	ShowResults(sOIA, sizeof(sOIA));
}

void CChildView::OnFunctionCopyFieldToString() 
{
	CString str1 = "<Enter start position>";
	CString str2 = "<Enter number of characters>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str1);
	WORD wLength = atoi(str2);
	LPBYTE pBuffer = new BYTE[wLength];
	CallWinHLLAPI(COPYFIELDTOSTRING, pBuffer, wLength, wPSPosition);
	ShowResults(pBuffer, wLength);
	delete[] pBuffer;
}

void CChildView::OnFunctionCopyPs() 
{
	// Get the session PS size
	BYTE sSessions[26][12];
	CallWinHLLAPI(QUERYSESSIONS, (LPBYTE)&sSessions, sizeof(sSessions));
	if (m_wReturnCode != WHLLOK)
	{
		ShowResults((LPBYTE)&sSessions, m_wLength * sizeof(sSessions[0]));
		return;
	}

	int nPSSize = 1920;
	for (int i = 0; i < m_wLength; i++)
	{
		if (sSessions[i][0] == m_cSessionID)
		{
			nPSSize = (sSessions[i][11] * 256) + sSessions[i][10];
			break;
		}
	}

	WORD wLength = nPSSize * (m_bEAB ? 2 : 1);	// * 2 if EAB session parameter used
	LPBYTE pBuffer = new BYTE[wLength];
	CallWinHLLAPI(COPYPS, pBuffer);
	ShowResults(pBuffer, wLength);
	delete[] pBuffer;
}

void CChildView::OnFunctionCopyPsToString() 
{
	CString str1 = "<Enter start position>";
	CString str2 = "<Enter number of characters>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str1);
	WORD wLength = atoi(str2);
	LPBYTE pBuffer = new BYTE[wLength];
	CallWinHLLAPI(COPYPSTOSTR, pBuffer, wLength, wPSPosition);
	ShowResults(pBuffer, wLength);
	delete[] pBuffer;
}

void CChildView::OnFunctionQueryFieldAttribute() 
{
	CString str1 = "<Enter field position>";
	if (!GetUserInput(&str1))
		return;

	WORD wPSPosition = atoi(str1);
	CallWinHLLAPI(QUERYFIELDATTRIBUTE, NULL, 0, wPSPosition);
	ShowResults();
}

void CChildView::OnFunctionStartHostNotify() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(STARTHOSTNOTIFICATION, (LPBYTE)((LPCTSTR)str1), 256);
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionStopHostNotify() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(STOPHOSTNOTIFICATION, (LPBYTE)((LPCTSTR)str1));
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionPause() 
{
	CString str1 = "<Enter wait interval>";
	if (!GetUserInput(&str1))
		return;

	WORD wInterval = atoi(str1);
	CallWinHLLAPI(PAUSE, NULL, wInterval);
	ShowResults();
}

void CChildView::OnFunctionQueryHostUpdate() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(QUERYHOSTUPDATE, (LPBYTE)((LPCTSTR)str1));
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionFindFieldLength() 
{
	CString str1 = "<find parms>";
	CString str2 = "<Start position>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str2);
	CallWinHLLAPI(FINDFIELDLENGTH, (LPBYTE)((LPCTSTR)str1), 0, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str1), 2);
}

void CChildView::OnFunctionFindFieldPosition() 
{
	CString str1 = "<find parms>";
	CString str2 = "<Start position>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str2);
	CallWinHLLAPI(FINDFIELDPOSITION, (LPBYTE)((LPCTSTR)str1), 0, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str1), 2);
}

void CChildView::OnFunctionSendKey() 
{
	CString str1 = "<Keystroke string>";
	if (!GetUserInput(&str1))
		return;

	WORD wLength = str1.GetLength();
	CallWinHLLAPI(SENDKEY, (LPBYTE)((LPCTSTR)str1), wLength);
	ShowResults((LPBYTE)((LPCTSTR)str1), wLength);
}

void CChildView::OnFunctionReserve() 
{
	CallWinHLLAPI(RESERVE);
	ShowResults();
}

void CChildView::OnFunctionRelease() 
{
	CallWinHLLAPI(RELEASE);
	ShowResults();
}

void CChildView::OnFunctionStartKeystrokeIntercept() 
{
	CString str1 = m_cSessionID;
	str1 += "<+ D = AID only or L = all keystrokes>";
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(STARTKSINTERCEPT, (LPBYTE)((LPCTSTR)str1), 256);
	ShowResults((LPBYTE)((LPCTSTR)str1), 6);
}

void CChildView::OnFunctionStopKeystrokeIntercept() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(STOPKSINTERCEPT, (LPBYTE)((LPCTSTR)str1));
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionGetKey() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	for (int i = 1; i < 8; i++)
		str1 += ' ';
	CallWinHLLAPI(GETKEY, (LPBYTE)((LPCTSTR)str1));
	ShowResults((LPBYTE)((LPCTSTR)str1), 8);
}

void CChildView::OnFunctionPostInterceptStatus() 
{
	CString str1 = m_cSessionID;
	str1 += " <+ A to accept or R to reject>";
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(POSTINTERCEPTSTATUS, (LPBYTE)((LPCTSTR)str1));
	ShowResults((LPBYTE)((LPCTSTR)str1), 2);
}

void CChildView::OnFunctionCopyStringToPs() 
{
	CString str1 = "<Enter start position>";
	CString str2 = "<Enter string to copy>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str1);
	WORD wLength = str2.GetLength();
	CallWinHLLAPI(COPYSTRTOPS, (LPBYTE)((LPCTSTR)str2), wLength, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str2), wLength);
}

void CChildView::OnFunctionCopyStringToField() 
{
	CString str1 = "<Enter start position>";
	CString str2 = "<Enter string to copy>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wPSPosition = atoi(str1);
	WORD wLength = str2.GetLength();
	CallWinHLLAPI(COPYSTRINGTOFIELD, (LPBYTE)((LPCTSTR)str2), wLength, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str2), wLength);
}

void CChildView::OnFunctionResetSystem() 
{
	CallWinHLLAPI(RESETSYSTEM);
	ShowResults();
}

void CChildView::OnFunctionWait() 
{
	CallWinHLLAPI(WAIT);
	ShowResults();
}

void CChildView::OnFunctionSearchField() 
{
	CString str1 = "<Search string>";
	CString str2 = "<Start position>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wLength = str1.GetLength();
	WORD wPSPosition = atoi(str2);
	CallWinHLLAPI(SEARCHFIELD, (LPBYTE)((LPCTSTR)str1), wLength, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str1), wLength);
}

void CChildView::OnFunctionSearchPs() 
{
	CString str1 = "<Search string>";
	CString str2 = "<Start position>";
	if (!GetUserInput(&str1, &str2))
		return;

	WORD wLength = str1.GetLength();
	WORD wPSPosition = atoi(str2);
	CallWinHLLAPI(SEARCHPS, (LPBYTE)((LPCTSTR)str1), wLength, wPSPosition);
	ShowResults((LPBYTE)((LPCTSTR)str1), wLength);
}

void CChildView::OnFunctionSendFile() 
{
	if (!GetUserInput(&m_strSendCommand))
		return;

	WORD wLength = m_strSendCommand.GetLength();
	CallWinHLLAPI(SENDFILE, (LPBYTE)((LPCTSTR)m_strSendCommand), wLength);
	ShowResults((LPBYTE)((LPCTSTR)m_strSendCommand), wLength);
}

void CChildView::OnFunctionReceiveFile() 
{
	if (!GetUserInput(&m_strReceiveCommand))
		return;

	WORD wLength = m_strReceiveCommand.GetLength();
	CallWinHLLAPI(RECEIVEFILE, (LPBYTE)((LPCTSTR)m_strReceiveCommand), wLength);
	ShowResults((LPBYTE)((LPCTSTR)m_strReceiveCommand), wLength);
}

void CChildView::OnFunctionStartCloseIntercept() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	BYTE sData[5];
	sData[0] = str1.IsEmpty() ? m_cSessionID : str1[0];
	CallWinHLLAPI(STARTCLOSEINTERCEPT, sData, 5);
	ShowResults(sData, 5);
}

void CChildView::OnFunctionStopCloseIntercept() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(STOPCLOSEINTERCEPT, (LPBYTE)((LPCTSTR)str1), 1);
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionQueryCloseIntercept() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(QUERYCLOSEINTERCEPT, (LPBYTE)((LPCTSTR)str1), 1);
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionConnectWindowServices() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(CONNECTWINDOWSERVICES, (LPBYTE)((LPCTSTR)str1), 1);
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionDisconnectWindowServices() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	CallWinHLLAPI(DISCONNECTWINDOWSERVICES, (LPBYTE)((LPCTSTR)str1), 1);
	ShowResults((LPBYTE)((LPCTSTR)str1), 1);
}

void CChildView::OnFunctionQueryWindowCoordinates() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

	BYTE sData[17];
	sData[0] = str1.IsEmpty() ? m_cSessionID : str1[0];
	CallWinHLLAPI(QUERYWINDOWCOORDINATES, sData, 17);
	ShowResults(sData, 17);
}

void CChildView::OnFunctionWindowStatusQuery() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

struct {
	char	cSessionID;
	BYTE	bRequestType;
	WORD	wShowState;
	short	nXUpperLeft;
	short	nYUpperLeft;
	short	nWidth;
	short	nHeight;
	long	nZOrder;
} WindowStatus_1;

struct {
	char	cSessionID;
	BYTE	bRequestType;
	WORD	wShowState;
	short	nFontHeight;
	short	nFontWidth;
	short	nLeftMargin;
	short	nTopMargin;
	short	nFirstRow;
	short	nFirstCol;
	HWND	hWnd;
} WindowStatus_2;

	// Query
	LPBYTE pWindowStatus = (LPBYTE)&WindowStatus_1;
	WindowStatus_1.cSessionID = str1.IsEmpty() ? m_cSessionID : str1[0];
	WindowStatus_1.bRequestType = WHLL_WINDOWSTATUS_QUERY;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	short nXUpperLeft = WindowStatus_1.nXUpperLeft;
	short nYUpperLeft = WindowStatus_1.nYUpperLeft;
	short nWidth = WindowStatus_1.nWidth;
	short nHeight = WindowStatus_1.nHeight;

	// Extended query
	pWindowStatus = (LPBYTE)&WindowStatus_2;
	WindowStatus_2.cSessionID = str1.IsEmpty() ? m_cSessionID : str1[0];
	WindowStatus_2.bRequestType = WHLL_WINDOWSTATUS_EXTQUERY;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_2));
	ShowResults(pWindowStatus, sizeof(WindowStatus_2));
}

void CChildView::OnFunctionWindowStatusSet() 
{
	CString str1 = m_cSessionID;
	if (!GetUserInput(&str1))
		return;

struct {
	char	cSessionID;
	BYTE	bRequestType;
	WORD	wShowState;
	short	nXUpperLeft;
	short	nYUpperLeft;
	short	nWidth;
	short	nHeight;
	long	nZOrder;
} WindowStatus_1;

	// Query (to get original window coordinates)
	LPBYTE pWindowStatus = (LPBYTE)&WindowStatus_1;
	WindowStatus_1.cSessionID = str1.IsEmpty() ? m_cSessionID : str1[0];
	WindowStatus_1.bRequestType = WHLL_WINDOWSTATUS_QUERY;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	short nXUpperLeft = WindowStatus_1.nXUpperLeft;
	short nYUpperLeft = WindowStatus_1.nYUpperLeft;
	short nWidth = WindowStatus_1.nWidth;
	short nHeight = WindowStatus_1.nHeight;

	// Minimize window
	WindowStatus_1.bRequestType = WHLL_WINDOWSTATUS_SET;
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_MINIMIZE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be minimized");

	// Maximize window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_MAXIMIZE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be maximized");

	// Restore window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_RESTORE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be restored");

	// Hide window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_HIDE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be hidden");

	// Show window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_SHOW;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be visible");

	// Size window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_SIZE;
	WindowStatus_1.nWidth = 800;
	WindowStatus_1.nHeight = 600;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be 800x600");

	// Resize window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_SIZE;
	WindowStatus_1.nWidth = nWidth;
	WindowStatus_1.nHeight = nHeight;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be original size");

	// Move window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_MOVE;
	WindowStatus_1.nXUpperLeft = 0;
	WindowStatus_1.nYUpperLeft = 0;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be top left");

	// Move window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_MOVE;
	WindowStatus_1.nXUpperLeft = nXUpperLeft;
	WindowStatus_1.nYUpperLeft = nYUpperLeft;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be original position");

	// Deactivate window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_DEACTIVATE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be deactivated");

	// Activate window
	WindowStatus_1.wShowState = WHLL_WINDOWSTATUS_ACTIVATE;
	CallWinHLLAPI(WINDOWSTATUS, pWindowStatus, sizeof(WindowStatus_1));
	ShowResults(pWindowStatus, sizeof(WindowStatus_1));
	AfxMessageBox("Window should be activated");
}

void CChildView::OnFunctionChangePSWindowName() 
{
	CString str1 = m_cSessionID;
	CString str2 = "<Enter new window name (clear to reset)>";
	if (!GetUserInput(&str1, &str2))
		return;

	CString str3 = str1.IsEmpty() ? m_cSessionID : str1[0];
	if (str2.IsEmpty())
		str3 += WHLL_CHANGEPSNAME_RESET;
	else
	{
		str3 += WHLL_CHANGEPSNAME_SET;
		str3 += str2;
	}
	WORD wLength = min(63, str3.GetLength());
	CallWinHLLAPI(CHANGEPSNAME, (LPBYTE)(LPCTSTR)str3, wLength);
	ShowResults((LPBYTE)(LPCTSTR)str3, wLength);
}

void CChildView::OnFunctionStartEmulator() 
{
	CString str1 = m_strEmulatorPath;
	CString str2 = m_strEmulatorParameters;
	if (!GetUserInput(&str1, &str2))
		return;
	m_strEmulatorPath = str1;
	m_strEmulatorParameters = str2;
	int nRet = DoShellExecute("open", str1, str2, SW_SHOW, TRUE);

	CString str;
	m_astrResults.Add("");
	m_astrResults.Add("Start emulator");
	str.Format("    Return code: %d", nRet);
	m_astrResults.Add(str);
	str.Format("           Path: %s", str1);
	m_astrResults.Add(str);
	str.Format("     Parameters: %s", str2);
	m_astrResults.Add(str);

	UpdateScrollSizes(max(m_astrResults.GetSize() - m_nVPageSize, 0));
	Invalidate();
}

////////////////////////////////////////////////////////////////////////
/// Helpers
///

void CChildView::CallWinHLLAPI(WORD wFunction, LPBYTE lpbyString, WORD wLength, WORD wPSPosition)
{
	m_wFunction = wFunction;
	m_wLength = m_wCallLength = wLength;
	m_wReturnCode = m_wPSPosition = wPSPosition;
	if (m_pfnWinHLLAPI)
		m_pfnWinHLLAPI(&m_wFunction, lpbyString, &m_wLength, &m_wReturnCode);
	else
		m_wReturnCode = WHLLSYSERROR;
}

BOOL CChildView::GetUserInput(CString* pStr1, CString* pStr2 /*=NULL*/)
{
	WHLLAPI3270UserInput dlg;
	dlg.m_strString1 = *pStr1;
	if (pStr2)
		dlg.m_strString2 = *pStr2;
	if (dlg.DoModal() == IDCANCEL)
		return FALSE;
	*pStr1 = dlg.m_strString1;
	if (pStr2)
		*pStr2 = dlg.m_strString2;
	return TRUE;
}

void CChildView::ShowResults(LPBYTE lpbyString, int nCount)
{
	char szFunction[]	= "       Function: %d (%s)";
	char szDataLength[]	= "    Data length: %d";
	char szPSPosition[]	= "    PS Position: %d";
	char szRetString[]	= "         String:";
	char szRetLength[]	= "Returned length: %d";
	char szRetCode[]	= "    Return code: %d (%s)";

	if (m_astrResults.GetSize() > 0)
	{
		m_astrResults.Add("");
		while (m_astrResults.GetSize() > 5000)
		{
			// Limit output size so we don't run out of memory
			int nCount = 0;
			while (!m_astrResults[nCount].IsEmpty())
				nCount++;
			m_astrResults.RemoveAt(0, nCount + 1);
		}
	}

	CString str;
	str.Format(szFunction, m_wFunction, GetFunctionName(m_wFunction));
	m_astrResults.Add(str);
	str.Format(szDataLength, m_wCallLength);
	m_astrResults.Add(str);
	str.Format(szPSPosition, m_wPSPosition);
	m_astrResults.Add(str);

	if (lpbyString)
	{
		// Single line display - left is hex, right is ASCII
		char szPrefix[64];
		strcpy(szPrefix, szRetString);
		int nPrefixLen = strlen(szPrefix);

#define _WIDTH 16
		int nWidth = _WIDTH;
		for (int i = 0; i < nCount; i+=nWidth)
		{
			char szString[(_WIDTH*4) + 2];
			memset(szString, ' ', sizeof(szString));
			if (i > 0)
			{
				memset(szPrefix, ' ', nPrefixLen);
				sprintf(szPrefix + nPrefixLen - 5, "%.4x:", i);
			}

			char* pHex = szString;
			char* pChar = szString + (nWidth*3) + 1;
			for (int j = i; j < nCount && j < i + nWidth; j++, pHex+=3, pChar++)
			{
				sprintf(pHex, "%.2x ", lpbyString[j]);
				*pChar = isprint(lpbyString[j]) ? lpbyString[j] : '.';
			}
			*pHex = ' ';
			*pChar = '\0';
			str.Format("%s %s", szPrefix, szString);
			m_astrResults.Add(str);
		}
	}
	str.Format(szRetLength, m_wLength);
	m_astrResults.Add(str);
	str.Format(szRetCode, m_wReturnCode, GetReturnCodeVerbose(m_wReturnCode));
	m_astrResults.Add(str);

	UpdateScrollSizes(max(m_astrResults.GetSize() - m_nVPageSize, 0));
	Invalidate();
}

CString CChildView::GetFunctionName(WORD wFunction)
{
static const struct 
{
	char*	pName;
	WORD	wFuncCode;
} FuncCodeTable[] = 
{
	"OEMFUNCTION",				0,  /* OEM Function */
	"CONNECTPS",				1,  /* Connect Presentation Space */
	"DISCONNECTPS",				2,  /* Disconnect Presentation Space */
	"SENDKEY",					3,  /* Send Key */
	"WAIT",						4,  /* Wait */
	"COPYPS",					5,  /* Copy Presentation Space */
	"SEARCHPS",					6,  /* Search Presentation Space */
	"QUERYCURSORLOC",			7,  /* Query Cursor Location */
	"COPYPSTOSTR",				8,  /* Copy Presentation Space To String */
	"SETSESSIONPARAMETERS",		9,  /* Set Session Parameters */
	"QUERYSESSIONS",			10,  /* Query Sessions */
	"RESERVE",					11,  /* Reserve */
	"RELEASE",					12,  /* Release */
	"COPYOIA",					13,  /* Copy OIA Information */
	"QUERYFIELDATTRIBUTE",		14,  /* Query Field Attribute */
	"COPYSTRTOPS",				15,  /* Copy String To Presentation Space */
	"STORAGEMGR",				17,  /* Storage Manager */
	"PAUSE",					18,  /* Pause */
	"QUERYSYSTEM",				20,  /* Query System */
	"RESETSYSTEM",				21,  /* Reset System */
	"QUERYSESSIONSTATUS",		22,  /* Query Session Status */
	"STARTHOSTNOTIFICATION",	23,  /* Start Host Notification */
	"QUERYHOSTUPDATE",			24,  /* Query Host Update */
	"STOPHOSTNOTIFICATION",		25,  /* Stop Host Notification */
	"SEARCHFIELD",				30,  /* Search Field */
	"FINDFIELDPOSITION",		31,  /* Find Field Position */
	"FINDFIELDLENGTH",			32,  /* Find Field Length */
	"COPYSTRINGTOFIELD",		33,  /* Copy String To Field */
	"COPYFIELDTOSTRING",		34,  /* Copy String To Field */
	"SETCURSOR",				40,  /* Set Cursor */
	"STARTCLOSEINTERCEPT",		41,  /* Start Close Intercept */
	"QUERYCLOSEINTERCEPT",		42,  /* Query Close Intercept */
	"STOPCLOSEINTERCEPT",		43,  /* Stop Close Intercept */
	"STARTKSINTERCEPT",			50,  /* Start Keystroke Intercept */
	"GETKEY",					51,  /* Get Key */
	"POSTINTERCEPTSTATUS",		52,  /* Post Intercept Status */
	"STOPKSINTERCEPT",			53,  /* Stop  Keystroke Intercept */
	"LOCKPSAPI",				60,  /* Lock Presentation Space API */
	"LOCKWSAPI",				61,  /* Lock Window Services API */
	"SENDFILE",					90,  /* Send File */
	"RECEIVEFILE",				91,  /* Receive File */
	"CONVERT",					99,  /* Convert Position or RowCol */
	"CONNECTWINDOWSERVICES",	101,  /* Connect Window Services */
	"DISCONNECTWINDOWSERVICES",	102,  /* Disconnect Window Services */
	"QUERYWINDOWCOORDINATES",	103,  /* Query or Set Window Coordinates */
	"WINDOWSTATUS",				104,  /* Query or Set Window Status */
	"CHANGEPSNAME",				105,  /* Change Presentation Space Name */
	"CONNECTSTRFLDS",			120,  /* Connect Structured Fields */
	"DISCONSTRFLDS",			121,  /* Disconnect Structured Fields */
	"QUERYCOMMBUFSIZ",			122,  /* Query Communications Buffer Size */
	"ALLOCCOMMBUFF",			123,  /* Allocate Communications Buffer */
	"FREECOMMBUFF",				124,  /* Free Communications Buffer */
	"GETREQUESTCOMP",			125,  /* Get Request Completion */
	"READSTRFLDS",				126,  /* Read Structured Fields */
	"WRITESTRFLDS",				127,  /* Write Structured Fields */
};

	CString str = "INVALID FUNCTION CODE";
	for (int i = 0; i < _countof(FuncCodeTable); i++)
	{
		if (FuncCodeTable[i].wFuncCode == wFunction)
			return FuncCodeTable[i].pName;
	}
	return str;
}

CString CChildView::GetReturnCodeVerbose(int nReturnCode)
{
struct 
{
	char*	pDesc;
	int		nRetCode;
} RetCodeTable[] = 
{
	"WHLLOK",					0,		/* Successful */
	"WHLLNOTCONNECTED",			1,		/* Not Connected To Presentation Space */
	"WHLLBLOCKNOTAVAIL",		1,		/* Requested size is not available */
	"WHLLPARAMETERERROR",		2,		/* Parameter Error/Invalid Function */
	"WHLLBLOCKIDINVALID",		2,		/* Invalid Block ID was specified */
	"WHLLFTXCOMPLETE",			3,		/* File Transfer Complete */
	"WHLLPSBUSY",				4,		/* Presentation Space is Busy */
	"WHLLFTXSEGMENTED",			4,		/* File Transfer Complete / segmented */
	"WHLLINHIBITED",			5,		/* Inhibited/Keyboard Locked */
	"WHLLTRUNCATED",			7,		/* Invalid Presentation Space Position */
	"WHLLNOTAVAILABLE",			8,		/* Unavailable Operation */
	"WHLLSYSERROR",				9,		/* System Error */
	"WHLLNOTSUPPORTED",			10,		/* Function Not Supported */
	"WHLLUNAVAILABLE",			11,		/* Resource is unavailable */
	"WHLLPSENDED",				12,		/* The session was stopped */
	"WHLLUNDEFINEDKEY",			20,		/* Undefined Key Combination */
	"WHLLOIAUPDATE",			21,		/* OIA Updated */
	"WHLLPSUPDATE",				22,		/* PS Updated */
	"WHLLBOTHUPDATE",			23,		/* Both PS And OIA Updated */
	"WHLLNOFIELD",				24,		/* No Such Field Found */
	"WHLLNOKEYSTROKES",			25,		/* No Keystrokes are available */
	"WHLLPSCHANGED",			26,		/* PS or OIA changed */
	"WHLLFTXABORTED",			27,		/* File transfer aborted */
	"WHLLZEROLENFIELD",			28,		/* Field length is zero */
	"WHLLKEYOVERFLOW",			31,		/* Keystroke overflow */
	"WHLLSFACONN",				32,		/* Other application already connected */
	"WHLLTRANCANCLI",			34,		/* Message sent inbound to host cancelled */
	"WHLLTRANCANCL",			35,		/* Outbound trans from host cancelled */
	"WHLLHOSTCLOST",			36,		/* Contact with host was lost */
	"WHLLOKDISABLED",			37,		/* The function was successful */
	"WHLLNOTCOMPLETE",			38,		/* The requested fn was not completed */
	"WHLLSFDDM",				39,		/* One DDM session already connected */
	"WHLLSFDPEND",				40,		/* Disconnected w async requests pending */
	"WHLLBUFFINUSE",			41,		/* Specified buffer currently in use */
	"WHLLNOMATCH",				42,		/* No matching request found */
	"WHLLLOCKERROR",			43,		/* API already locked or unlocked */
	"WHLLINVALIDFUNCTIONNUM",	301,	/* Invalid function number */
	"WHLLFILENOTFOUND",			302,	/* File Not Found */
	"WHLLACCESSDENIED",			305,	/* Access Denied */
	"WHLLMEMORY",				308,	/* Insufficient Memory */
	"WHLLINVALIDENVIRONMENT",	310,	/* Invalid environment */
	"WHLLINVALIDFORMAT",		311,	/* Invalid format */
	"WHLLINVALIDPSID",			9998,	/* Invalid Presentation Space ID */
	"WHLLINVALIDRC",			9999,	/* Invalid Row or Column Code */
	"WHLLALREADY",				0xF000,	/* An async call is already outstanding */
	"WHLLINVALID",				0xF001,	/* Async Task Id is invalid */
	"WHLLCANCEL",				0xF002,	/* Blocking call was cancelled */
	"WHLLSYSNOTREADY",			0xF003,	/* Underlying subsystem not started */
	"WHLLVERNOTSUPPORTED",		0xF004,	/* Application version not supported */
};

	CString str = "INVALID RETURN CODE";
	for (int i = 0; i < _countof(RetCodeTable); i++)
	{
		if (RetCodeTable[i].nRetCode == nReturnCode)
			return RetCodeTable[i].pDesc;
	}
	return str;
}

CString CChildView::GetToken(CString& strString, LPCTSTR lpszCharSet /* = "," */)
{
	//
	// This function returns the first token in strString which
	// is delimited by one of the characters in lpszCharSet.
	// The returned token is removed from strString.
	//
	CString strResult;
	int nIndex = strString.FindOneOf(lpszCharSet);
	if (nIndex == -1)
	{
		// The delimiter was not found
		strResult = strString;
		strString.Empty();
	}
	else
	{
		strResult = strString.Left(nIndex);
		strString.Delete(0, nIndex + 1);
	}
	return strResult;
}

int CChildView::DoShellExecute(LPCTSTR lpszVerb, LPCTSTR lpszFile, LPCTSTR lpszParameters, int nShowCmd, BOOL bShowErr)
{
	// Returns 0 if success, otherwise the value of GetLastError()
	//
	// The return value of ShellExecute is cast as an HINSTANCE for
	// backward compatibility with 16-bit Microsoft Windows applications.
	// It is not a true HINSTANCE, however. The only thing that can be done
	// with the returned HINSTANCE is to cast it to an integer and compare
	// it with the value 32 or one of the error codes below.
	//
	// The following table lists the error values:
	// 0						The operating system is out of memory or resources. 
	// ERROR_FILE_NOT_FOUND		The specified file was not found. 
	// ERROR_PATH_NOT_FOUND		The specified path was not found. 
	// ERROR_BAD_FORMAT			The .exe file is invalid (non-Win32 .exe or error in .exe image). 
	// SE_ERR_ACCESSDENIED		The operating system denied access to the specified file.  
	// SE_ERR_ASSOCINCOMPLETE	The file name association is incomplete or invalid. 
	// SE_ERR_DDEBUSY			The DDE transaction could not be completed because other DDE transactions were being processed. 
	// SE_ERR_DDEFAIL			The DDE transaction failed. 
	// SE_ERR_DDETIMEOUT		The DDE transaction could not be completed because the request timed out. 
	// SE_ERR_DLLNOTFOUND		The specified dynamic-link library was not found.  
	// SE_ERR_FNF				The specified file was not found.  
	// SE_ERR_NOASSOC			There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable. 
	// SE_ERR_OOM				There was not enough memory to complete the operation. 
	// SE_ERR_PNF				The specified path was not found. 
	// SE_ERR_SHARE				A sharing violation occurred. 

	SHELLEXECUTEINFO sei;
	memset(&sei, 0, sizeof(SHELLEXECUTEINFO));
	sei.cbSize = sizeof(SHELLEXECUTEINFO);
	sei.fMask = bShowErr ? 0 : SEE_MASK_FLAG_NO_UI;
	sei.lpVerb = lpszVerb;
	sei.lpFile = lpszFile;
	sei.lpParameters = lpszParameters;
	sei.nShow = nShowCmd;
	if (ShellExecuteEx(&sei))
		return 0;
	return GetLastError();
}
