// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__EC1B79CC_B1A9_11D4_B609_0800460222F0__INCLUDED_)
#define AFX_CHILDVIEW_H__EC1B79CC_B1A9_11D4_B609_0800460222F0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WHLLAPI.h"

/////////////////////////////////////////////////////////////////////////////
// CChildView window
typedef int (WINAPI* PFNWinHLLAPIStartup) (WORD, LPWHLLAPIDATA);
typedef BOOL (WINAPI* PFNWinHLLAPICleanup) (void);
typedef void (WINAPI* PFNWinHLLAPI) (LPWORD, LPBYTE, LPWORD, LPWORD);

class CChildView : public CWnd
{
// Construction
public:
	CChildView();

// Attributes
public:

protected:
	char	m_cSessionID;
	CString m_strSendCommand;
	CString m_strReceiveCommand;
	CString m_strEmulatorPath;
	CString m_strEmulatorParameters;
	int		m_cx, m_cy;
	int		m_nVScrollPos;
	int		m_nVPageSize;
	BOOL	m_bEAB;

	WORD	m_wFunction;
	WORD	m_wLength;
	WORD	m_wCallLength;
	WORD	m_wPSPosition;
	WORD	m_wReturnCode;

	HMODULE				m_hLib;
	PFNWinHLLAPI		m_pfnWinHLLAPI;
	PFNWinHLLAPIStartup	m_pfnWinHLLAPIStartup;
	PFNWinHLLAPICleanup	m_pfnWinHLLAPICleanup;

	CStringArray	m_astrResults;
// Operations
public:

private:
	void UpdateScrollSizes(int nVScrollPos);
	BOOL GetUserInput(CString* pStr1, CString* pStr2 = NULL);
	CString GetFunctionName(WORD wFunction);
	CString GetReturnCodeVerbose(int nReturnCode);
	CString GetToken(CString& strString, LPCTSTR lpszCharSet = ",");
	void ShowResults(LPBYTE lpbyString = NULL, int nCount = 0);
	void CallWinHLLAPI(WORD wFunction, LPBYTE lpbyString = NULL, WORD wLength = 0, WORD wPSPosition = 0);
	int DoShellExecute(LPCTSTR lpszVerb, LPCTSTR lpszFile, LPCTSTR lpszParameters, int nShowCmd, BOOL bShowErr);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnFunctionConnectPS();
	afx_msg void OnFunctionDisconnectPS();
	afx_msg void OnFunctionConvert();
	afx_msg void OnFunctionSetSessionParms();
	afx_msg void OnFunctionSetCursor();
	afx_msg void OnFunctionQueryCursor();
	afx_msg void OnFunctionQuerySystem();
	afx_msg void OnFunctionQuerySessions();
	afx_msg void OnFunctionQuerySessionStatus();
	afx_msg void OnFunctionCopyFieldToString();
	afx_msg void OnFunctionCopyPs();
	afx_msg void OnFunctionCopyPsToString();
	afx_msg void OnFunctionQueryFieldAttribute();
	afx_msg void OnFunctionStartHostNotify();
	afx_msg void OnFunctionStopHostNotify();
	afx_msg void OnFunctionPause();
	afx_msg void OnFunctionQueryHostUpdate();
	afx_msg void OnFunctionFindFieldLength();
	afx_msg void OnFunctionFindFieldPosition();
	afx_msg void OnFunctionSendKey();
	afx_msg void OnFunctionReserve();
	afx_msg void OnFunctionRelease();
	afx_msg void OnFunctionStartKeystrokeIntercept();
	afx_msg void OnFunctionStopKeystrokeIntercept();
	afx_msg void OnFunctionGetKey();
	afx_msg void OnFunctionPostInterceptStatus();
	afx_msg void OnFunctionCopyStringToPs();
	afx_msg void OnFunctionCopyStringToField();
	afx_msg void OnFunctionResetSystem();
	afx_msg void OnFunctionWait();
	afx_msg void OnFunctionSearchField();
	afx_msg void OnFunctionSearchPs();
	afx_msg void OnFunctionSendFile();
	afx_msg void OnFunctionReceiveFile();
	afx_msg void OnFunctionCopyOIA();
	afx_msg void OnFunctionStartCloseIntercept();
	afx_msg void OnFunctionStopCloseIntercept();
	afx_msg void OnFunctionQueryCloseIntercept();
	afx_msg void OnFunctionConnectWindowServices();
	afx_msg void OnFunctionDisconnectWindowServices();
	afx_msg void OnFunctionQueryWindowCoordinates();
	afx_msg void OnFunctionWindowStatusQuery();
	afx_msg void OnFunctionWindowStatusSet();
	afx_msg void OnFunctionChangePSWindowName();
	afx_msg void OnFunctionStartEmulator();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__EC1B79CC_B1A9_11D4_B609_0800460222F0__INCLUDED_)
